////////////////////////////////////////////////////////////////////////////////
// Do not modify!
// Generated by codergen
////////////////////////////////////////////////////////////////////////////////


#ifndef GAPIC_CODER_MEMORY_H
#define GAPIC_CODER_MEMORY_H

namespace gapic {

class Encodable;
class Encoder;

namespace coder {
namespace memory {
    class Pointer: public Encodable {
    public:
        Pointer() = default;
        Pointer(uint64_t Address, uint32_t Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x32, 0x91, 0x20, 0x2c, 0x71, 0x1c, 0x99, 0xd3, 0xde, 0xad, 0xd6, 0xab, 0xac, 0x67, 0x78, 0xad, 0xfd, 0xb5, 0x05, 0xf9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        uint64_t mAddress;
        uint32_t mPool;
    };

    class Range: public Encodable {
    public:
        Range() = default;
        Range(uint64_t Base, uint64_t Size) :
            mBase(Base),
            mSize(Size) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x4d, 0x08, 0x43, 0xb3, 0xb7, 0x7d, 0x8c, 0x7b, 0x5f, 0x7f, 0x54, 0xb7, 0x7b, 0xa3, 0xd6, 0x55, 0x77, 0x01, 0x52, 0x2c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mBase);
            e->Uint64(this->mSize);
        }

        uint64_t mBase;
        uint64_t mSize;
    };



} // namespace memory
} // namespace coder
} // namespace gapic

#endif // GAPIC_CODER_MEMORY_H
